/* ppmavg.c  
**
** Calculates average pixel value of a ppm file.
** AJW, 1995
**
** Adopted from the netpbm package:
**
** Copyright (C) 1989 by Jef Poskanzer.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
*/

#include "ppm.h"


void
main( argc, argv )
    int argc;
    char* argv[];
    {
    FILE* ifp;
    pixel** pixels;
	pixval maxval;
    int argn, rows, cols, colors, i, j;
	float lumsum;
    char* usage = "[ppmfile]";

    ppm_init( &argc, argv );

    argn = 1;

    if ( argn != argc )
	{
	ifp = pm_openr( argv[argn] );
	argn++;
	}
    else
	ifp = stdin;

    if ( argn != argc )
	pm_usage( usage );

    pixels = ppm_readppm( ifp, &cols, &rows, &maxval );

    pm_close( ifp );

	lumsum = 0;

	for (i = 0; i < rows; i++)
		for (j = 0; j < cols; j++)
			lumsum += PPM_LUMIN(pixels[i][j]);

	printf("%d\n", (int) (lumsum / (rows * cols)));

    exit( 0 );
    }
